diff --git a/.gitlab-ci.yml b/.gitlab-ci.yml
index 076514ad4edfd0db912f90a829b0384353b6e9cd..b48a546de3a164774b37b7b90b9c541e60ff2a2a 100644
--- a/.gitlab-ci.yml
+++ b/.gitlab-ci.yml
@@ -16,6 +16,10 @@ after_script:
   stage: build
   script:
     - ./cicd_tests/do-build.sh
+  artifacts:
+    paths:
+    -  "./ps-install-*"
+
 
 # per os items
 do-build-ubuntu18:
diff --git a/cicd_tests/do-build.sh b/cicd_tests/do-build.sh
index 1d0f58c41970376c3b6e1846d8908b47a95e438f..860b35a632d5ebbc875cc008c296030c01749b75 100755
--- a/cicd_tests/do-build.sh
+++ b/cicd_tests/do-build.sh
@@ -3,23 +3,33 @@
 set -e
 set -x
 
-# gather info for debugging later, probably not necessary 
-pwd
-hostname
-whoami
-env|grep CICD
+main()
+{
 
-# puts peasoup_umbrella (and all submodules) in CICD_MODULE_WORK_DIR
-cicd_setup_module_dependency allnp/peasoup_umbrella.git
+	# gather info for debugging later, probably not necessary 
+	pwd
+	hostname
+	whoami
+	env|grep CICD
 
+	local orig_dir=$(pwd)
 
-# puts the version of zipr to test in peasoup_umbrella/zipr.
-cicd_put_module_in_tree peasoup_umbrella/zipr
+	# puts peasoup_umbrella (and all submodules) in CICD_MODULE_WORK_DIR
+	cicd_setup_module_dependency allnp/peasoup_umbrella.git
 
-# Build/run $PSZ, test result
-cd $CICD_MODULE_WORK_DIR/peasoup_umbrella
-source set_env_vars
-sudo ./get-peasoup-packages.sh all
-./build-all.sh
-dropdb $PGDATABASE 2>/dev/null || true ; ./postgres_setup.sh
 
+	# puts the version of zipr to test in peasoup_umbrella/zipr.
+	cicd_put_module_in_tree peasoup_umbrella/zipr
+
+	# Build/run $PSZ, test result
+	cd $CICD_MODULE_WORK_DIR/peasoup_umbrella
+	source set_env_vars
+	sudo ./get-peasoup-packages.sh all
+	./build-all.sh
+	dropdb $PGDATABASE 2>/dev/null || true ; ./postgres_setup.sh
+
+	cd $orig_dir
+	cp $CICD_MODULE_WORK_DIR/install ps-install-$OS
+}
+
+main "$@"